/**
 * Copyright (c) 2021 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Sukolsak Sakshuwong <sukolsak@stanford.edu>
 */
import { RuntimeContext } from '../../mol-task';
import { MeshExporter, AddMeshInput } from './mesh-exporter';
export declare type StlData = {
    stl: Uint8Array;
};
export declare class StlExporter extends MeshExporter<StlData> {
    readonly fileExtension = "stl";
    private triangleBuffers;
    private triangleCount;
    protected addMeshWithColors(input: AddMeshInput): Promise<void>;
    getData(): {
        stl: Uint8Array;
    };
    getBlob(ctx: RuntimeContext): Promise<Blob>;
}
